Skip to content
Get started

Webhook Deliveries

Manage AI agents within a workspace. Agents define AI behavior and tool access.

List webhook deliveries
client.Agents.WebhookDeliveries.List(ctx, workspaceID, agentID, query) (*CursorPagination[WebhookDelivery], error)
GET/v1/workspaces/{workspaceId}/agents/{agentId}/webhook_deliveries
ModelsExpand Collapse
type WebhookDelivery struct{…}

Webhook delivery details.

AgentID string

Related resources

AttemptCount int64
EventType WebhookDeliveryDataEventType

The type of objective event that triggered this webhook delivery

formatenum
One of the following:
const WebhookDeliveryDataEventTypeObjectiveEventTypeUnspecified WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_UNSPECIFIED"
const WebhookDeliveryDataEventTypeObjectiveEventTypeUserMessage WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_USER_MESSAGE"
const WebhookDeliveryDataEventTypeObjectiveEventTypeToolApprovalRequested WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_TOOL_APPROVAL_REQUESTED"
const WebhookDeliveryDataEventTypeObjectiveEventTypeToolApproved WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_TOOL_APPROVED"
const WebhookDeliveryDataEventTypeObjectiveEventTypeToolDenied WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_TOOL_DENIED"
const WebhookDeliveryDataEventTypeObjectiveEventTypeToolCalled WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_TOOL_CALLED"
const WebhookDeliveryDataEventTypeObjectiveEventTypeError WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_ERROR"
const WebhookDeliveryDataEventTypeObjectiveEventTypeAssistantMessage WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_ASSISTANT_MESSAGE"
const WebhookDeliveryDataEventTypeObjectiveEventTypeToolResult WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_TOOL_RESULT"
const WebhookDeliveryDataEventTypeObjectiveEventTypeToolError WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_TOOL_ERROR"
const WebhookDeliveryDataEventTypeObjectiveEventTypeContextWindowCompacted WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_CONTEXT_WINDOW_COMPACTED"
const WebhookDeliveryDataEventTypeObjectiveEventTypeMemoryRead WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_MEMORY_READ"
const WebhookDeliveryDataEventTypeObjectiveEventTypeCancelled WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_CANCELLED"
const WebhookDeliveryDataEventTypeObjectiveEventTypeSubAgentSpawned WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_SUB_AGENT_SPAWNED"
const WebhookDeliveryDataEventTypeObjectiveEventTypeSubAgentUpdated WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_SUB_AGENT_UPDATED"
const WebhookDeliveryDataEventTypeObjectiveEventTypeFinalized WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_FINALIZED"
HTTPStatusCode int64

Response details. The response body is not retained.

formatint32
LastAttemptAt Time
LatencyMs int64
ObjectiveEventID string
ObjectiveID string
ResponseContentLength string

Content length of the response body in bytes

Status WebhookDeliveryDataStatus
formatenum
One of the following:
const WebhookDeliveryDataStatusWebhookDeliveryStatusUnspecified WebhookDeliveryDataStatus = "WEBHOOK_DELIVERY_STATUS_UNSPECIFIED"
const WebhookDeliveryDataStatusWebhookDeliveryStatusPending WebhookDeliveryDataStatus = "WEBHOOK_DELIVERY_STATUS_PENDING"
const WebhookDeliveryDataStatusWebhookDeliveryStatusCompleted WebhookDeliveryDataStatus = "WEBHOOK_DELIVERY_STATUS_COMPLETED"
const WebhookDeliveryDataStatusWebhookDeliveryStatusFailed WebhookDeliveryDataStatus = "WEBHOOK_DELIVERY_STATUS_FAILED"
const WebhookDeliveryDataStatusWebhookDeliveryStatusDisabled WebhookDeliveryDataStatus = "WEBHOOK_DELIVERY_STATUS_DISABLED"
WebhookID string
WebhookURL string

Webhook delivery details

ErrorMessage stringOptional
ResponseHeaders map[string, string]Optional

Response headers received from the webhook endpoint

Metadata for ephemeral operations and activities (e.g., objectives, executions, runs)

ID string

Unique identifier for the operation (prefixed ULID, e.g., “obj_01HXK…”)

AccountID string

Account this operation belongs to for multi-tenant isolation (prefixed ULID)

CreatedAt Time

Timestamp when this operation was created ULID includes timestamp information, but this explicit field enables easier querying

formatdate-time
ProfileID string

ID of the actor (user or service account) that created this operation

WorkspaceID string

Workspace this operation belongs to for organizational grouping (prefixed ULID)

ExternalID stringOptional

External ID for the operation (e.g., a workflow ID from an external system)

Labels map[string, string]Optional

Arbitrary key-value pairs for categorization and filtering Examples: {“priority”: “high”, “source”: “api”, “workflow”: “onboarding”}

type WebhookDeliveryData struct{…}
AgentID string

Related resources

AttemptCount int64
EventType WebhookDeliveryDataEventType

The type of objective event that triggered this webhook delivery

formatenum
One of the following:
const WebhookDeliveryDataEventTypeObjectiveEventTypeUnspecified WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_UNSPECIFIED"
const WebhookDeliveryDataEventTypeObjectiveEventTypeUserMessage WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_USER_MESSAGE"
const WebhookDeliveryDataEventTypeObjectiveEventTypeToolApprovalRequested WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_TOOL_APPROVAL_REQUESTED"
const WebhookDeliveryDataEventTypeObjectiveEventTypeToolApproved WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_TOOL_APPROVED"
const WebhookDeliveryDataEventTypeObjectiveEventTypeToolDenied WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_TOOL_DENIED"
const WebhookDeliveryDataEventTypeObjectiveEventTypeToolCalled WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_TOOL_CALLED"
const WebhookDeliveryDataEventTypeObjectiveEventTypeError WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_ERROR"
const WebhookDeliveryDataEventTypeObjectiveEventTypeAssistantMessage WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_ASSISTANT_MESSAGE"
const WebhookDeliveryDataEventTypeObjectiveEventTypeToolResult WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_TOOL_RESULT"
const WebhookDeliveryDataEventTypeObjectiveEventTypeToolError WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_TOOL_ERROR"
const WebhookDeliveryDataEventTypeObjectiveEventTypeContextWindowCompacted WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_CONTEXT_WINDOW_COMPACTED"
const WebhookDeliveryDataEventTypeObjectiveEventTypeMemoryRead WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_MEMORY_READ"
const WebhookDeliveryDataEventTypeObjectiveEventTypeCancelled WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_CANCELLED"
const WebhookDeliveryDataEventTypeObjectiveEventTypeSubAgentSpawned WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_SUB_AGENT_SPAWNED"
const WebhookDeliveryDataEventTypeObjectiveEventTypeSubAgentUpdated WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_SUB_AGENT_UPDATED"
const WebhookDeliveryDataEventTypeObjectiveEventTypeFinalized WebhookDeliveryDataEventType = "OBJECTIVE_EVENT_TYPE_FINALIZED"
HTTPStatusCode int64

Response details. The response body is not retained.

formatint32
LastAttemptAt Time
LatencyMs int64
ObjectiveEventID string
ObjectiveID string
ResponseContentLength string

Content length of the response body in bytes

Status WebhookDeliveryDataStatus
formatenum
One of the following:
const WebhookDeliveryDataStatusWebhookDeliveryStatusUnspecified WebhookDeliveryDataStatus = "WEBHOOK_DELIVERY_STATUS_UNSPECIFIED"
const WebhookDeliveryDataStatusWebhookDeliveryStatusPending WebhookDeliveryDataStatus = "WEBHOOK_DELIVERY_STATUS_PENDING"
const WebhookDeliveryDataStatusWebhookDeliveryStatusCompleted WebhookDeliveryDataStatus = "WEBHOOK_DELIVERY_STATUS_COMPLETED"
const WebhookDeliveryDataStatusWebhookDeliveryStatusFailed WebhookDeliveryDataStatus = "WEBHOOK_DELIVERY_STATUS_FAILED"
const WebhookDeliveryDataStatusWebhookDeliveryStatusDisabled WebhookDeliveryDataStatus = "WEBHOOK_DELIVERY_STATUS_DISABLED"
WebhookID string
WebhookURL string

Webhook delivery details

ErrorMessage stringOptional
ResponseHeaders map[string, string]Optional

Response headers received from the webhook endpoint